#include <mega8.h>
#include <stdio.h>
#include <delay.h>
#define SCK 5
#define MOSI 3
#define CS 0
#define SS 2
#define     POWERUP         0x20
#define     SETPLAY         0xE0
#define     PLAY            0XF0
#define     SETREC          0XA0
#define     REC             0XB0
#define     STOPPWRDN       0X10
#define     STOP            0X30
#define play_key PIND.7
#define rec_key PIND.6
#define stop_key PIND.5
#define rec_led PORTD.0
#define play_led PORTD.1
unsigned char spi(unsigned char data);
void playback(void);
void record(void);
void stop(void);
void main()
{

DDRB|=((1<<CS)|(1<<SCK)|(1<<MOSI)|(1<<SS));
SPCR=((1<<SPE)|(1<<MSTR)|(1<<SPR1)|(1<<SPR0)|(1<<DORD));
MCUCR=0x00;
GICR=0xc0;
PORTB|=1<<CS;
DDRD=0X03;
PORTD=0XE0;
DDRC=0XFF;

//#asm("sei")
while(1)
    {  
      play_led=0;
      rec_led=0;
      if(!play_key)
        {
          delay_ms(300);
          playback();  
          play_led=1;
          rec_led=0;
          while(1)
            {
              if(!stop_key)
                { 
                  delay_ms(300);
                  stop();  
                  goto st;
                }
            }
        } 
        if(!rec_key)
        {
          delay_ms(300);
          record(); 
          play_led=0;
          rec_led=1;
          while(1)
            {
              if(!stop_key)
                { 
                  delay_ms(300);
                  stop(); 
                  goto st;
                }
            }
        }
        
      st:
       
    }
}
unsigned char spi(unsigned char data)
{
SPDR=data;
while(!(SPSR & 0X80));
}
interrupt [EXT_INT0] void external_int0_INT(void) 
{
#asm("cli")

#asm("sei")
}
interrupt [EXT_INT1] void external_int1_RAC(void) 
{
#asm("cli")

#asm("sei")
}
void playback(void)
{
PORTD.0=1;
PORTD.1=0;
PORTB&=~(1<<CS);
spi(POWERUP);
PORTB|=1<<CS;
delay_ms(30);
PORTB&=~(1<<CS);
spi(0x00);
spi(0x00);
spi(SETPLAY);
PORTB|=1<<CS;

PORTB&=~(1<<CS);
spi(PLAY);
PORTB|=1<<CS;
}
void record(void)
{
PORTD.0=0;
PORTD.1=1;
PORTB&=~(1<<CS);
spi(POWERUP);
PORTB|=1<<CS;
delay_ms(25);
PORTB&=~(1<<CS);
spi(POWERUP);
PORTB|=1<<CS;
delay_ms(100);
PORTB&=~(1<<CS);
spi(0x00);
spi(0x00);
spi(SETREC);
PORTB|=1<<CS;

PORTB&=~(1<<CS);
spi(REC);
PORTB|=1<<CS;
}
void stop(void)
{
PORTB&=~(1<<CS);
PORTC=spi(STOP)>>3;
PORTB|=1<<CS;
delay_ms(5);

}